/***********************************************************************
 * Copyright 2003-2010 Netlogic Microsystems (??Netlogic??). All rights
 * reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 * *****************************#NETL_2#********************************/
/* Example code for uCore */
#include <stdint.h>

#include "ucore.h"

int main(void)
{
	uint32_t rx_pkt_ready = 0;
	int intf = 0;
	int hw_parser_error = 0;
	int context = 0;
	int n_cachelines = 1518 >> 6; /* Number of cachelines in Eth MTU */

	for (;;) {
		rx_pkt_ready = wait_for_packet();

		/* parsed values are not used! */
		intf = rx_pkt_ready & 0x1f;
		context = (rx_pkt_ready >> 13) & 0x3ff;
		hw_parser_error = (rx_pkt_ready >> 23) & 0x1;

		packet_dist( VAL_PDL(0) | VAL_PDM(FWD_DIST_VEC));

		packet_done(n_cachelines << 20);
	}

	/* should never come here */
	return 0;
}
