/***********************************************************************
 * Copyright 2003-2010 Netlogic Microsystems (??Netlogic??). All rights
 * reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 * *****************************#NETL_2#********************************/
/* Example code for uCore */
#include <stdint.h>

#define PACKET_MEMORY       (0xFFE00)
#define PACKET_DATA_OFFSET  (64)

static __inline__ void packet_done(uint32_t ucore_outbuf_done) {
	__asm__ volatile (
		"li	$8, 0x8000\n"
		"sw	%0, ($8)\n"
		:
		: "r"(ucore_outbuf_done)
		: "$8"
		);
}

static __inline__ void packet_dist(uint32_t pkt_dist) {
	__asm__ volatile (
		"li	$8, 0x8030\n"
		"sw	%0, ($8)\n"
		:
		: "r"(pkt_dist)
		: "$8"
		);
}

static __inline__ uint32_t ld_packet_dist(void) {
    uint32_t dist;

	__asm__ volatile (
		"li	$8, 0x8030\n"
		"lw	%0, ($8)\n"
		: "=r"(dist)
		: 
		: "$8"
		);
return dist;

}

static __inline__ uint32_t wait_for_packet(void) {
	uint32_t ucore_rx_pkt_rdy;
	__asm__ volatile (
		"li	$8, 0x8004\n"
		"lw	%0, ($8)\n"
		: "=r"(ucore_rx_pkt_rdy)
		:
		: "$8"
		);
	return ucore_rx_pkt_rdy;
}
static __inline__ uint32_t write_reg(uint32_t reg_num, uint32_t val) {
    uint32_t *reg = (uint32_t *) reg_num;
    return  ( *reg = val);
}

#define UCORE_PKT_DIST          0x8030
#define VAL_DEST(x)         (x & 0x3ff)<<8
#define VAL_PDM(x)          (x & 0x7)

int main(void) {
	uint32_t *pkt_data32 = (uint32_t *)(PACKET_MEMORY + PACKET_DATA_OFFSET);
//    uint32_t *ucore_pkt_dist = (uint32_t *) UCORE_PKT_DIST;
    
	for (;;) {
		wait_for_packet();
        
        
        packet_dist(VAL_PDM(3)|VAL_DEST(0));

		packet_done(0);
	}

	/* should never come here */
	return 0;
}
